<?php
class SPEClass{

    private static $instance;
    private function __construct() { } 
    private function __clone(){} 
    
 
    public static function getInstance ()
    {
        if (self::$instance === null) {
            self::$instance = new SPEClass();
        }
        return self::$instance;
 
        return (self::$instance === null) ? self::$instance = new SPEClass() : self::$instance;
    }
    
    public function editHeader(){
        //extrabrowser is loaded no matter its used or not
        ?>
            <link rel="stylesheet" href="../plugins/SpecialPagesExtras/css/extraBrowser.css" />
            <link rel="stylesheet" href="../plugins/SpecialPagesExtras/css/edit.css" />
            <script type="text/javascript" src="../plugins/SpecialPagesExtras/js/jquery-ui.sort.min.js"></script>
            <script type="text/javascript" src="../plugins/SpecialPagesExtras/js/jquery.extraBrowser.js"></script>
        <?php
    }
    
    public function editExtras($specialName){
        $settings = $this->loadSpecialPageSettings($specialName);

        if (empty($settings))
            return;
            
        $pageData = @$settings['pageData'];
        $fieldsData = @$settings['fieldsData'];
        
        $imageFieldNames = array();
        
        //if extra browser is on, then find all fields that has type of image and pass it to JS
        if (@$pageData['extra-browser']){ //silent error, for old versions that do not have tihs settings
            require_once(GSPLUGINPATH.'i18n_specialpages/specialpages.class.php');
            $specialSettings = I18nSpecialPages::getSettings($specialName);
            
            for ($i = 0; $i < count($specialSettings['fields']); $i++) {
                $field = $specialSettings['fields'][$i];
                if ($field['type'] == 'image')
                    $imageFieldNames[] = array('name' => strtolower($field['name']), 'index' => $i + 1); //lower is must have, +1 is to match specialepages edit.php
            }
        }

        include('editScripts.php'); //include all js 
        
        if (@$pageData['extra-browser'] && count($imageFieldNames))
            include('extraBrowser.html'); //include extraBrowseer
    }  

   
    //php security check for required and regex fields
    public function editValidationCheck(){
        $settings = $this->loadSpecialPageSettings(@$_POST['post-special']);
        
        if (empty($settings))
            return;
			
		$invalidFields = array();
            
        $pattern = '/\s|<br\s*?\/>/mi'; //trim pattern
              
        if ( $settings['pageData']['content-required'] ){
            $content =  @$_POST['post-content'];
            $content = trim(preg_replace($pattern, '', $content)); //same pattern as in js
            
            if ($content == '')
                $invalidFields[] = 'post-content'; //;die('SpecialPagesExtras "content-required" security!');
        }
        
        if (!isset($settings['fieldsData']))
            return $invalidFields;
        
        for ($i = 0; $i < count($settings['fieldsData']); $i++) {
            $fData = $settings['fieldsData'][$i];
            $value = @$_POST['post-sp-'.$fData['name']];
			
            if ($fData['required']){ //not required
				$testVal = preg_replace($pattern, '', $value); //pattern 
				
				if (@$fData['new-type'] == 'multitext')
					$testVal = str_replace('||', '', $testVal); //remove multitext separator chars         

				if (@$fData['new-type'] == 'multiimage')
					$testVal = str_replace('||', '', $testVal); //remove multiimage separator chars 

				$testVal = trim($testVal);
				
				if ($testVal == ''){
					$invalidFields[] = 'post-sp-'.$fData['name'];
					continue;
				}
			}     

			//regex check
			if (@$fData['regex']){ 
				if (@$fData['new-type'] == 'multitext'){ //when multitext store indexes of invalid values
					$vals = explode('||', $value);
					$notValidIdx = array();
					
					for ($n = 0; $n < count($vals); $n++) {
						if (!preg_match ( $fData['regex'], $vals[$n])){
							$notValidIdx[] = $n;
						}
					}
					
					if (!empty($notValidIdx))
						$invalidFields[] = 'post-sp-'.$fData['name'].'!'.implode(',',$notValidIdx);
				}
				else{
					if (!preg_match ( $fData['regex'], $value)){
						$invalidFields[] = 'post-sp-'.$fData['name'];
					}
				}
			}
        }
		
		return $invalidFields;
    }    


    public function confHeader(){
        ?>
            <link rel="stylesheet" href="../plugins/SpecialPagesExtras/css/configure.css" />
        <?php
    }
    
    //used when GS deletes file from uploads, delete cached thumb
    public function onFileDelete(){    
        $path = (isset($_GET['path'])) ? $_GET['path'] : '';
        $id = $_GET['file'];            
        $filepath = GSDATAUPLOADPATH . $path;
        $file =  $filepath . $id;
        
        $uploadsDirPart = str_replace(GSDATAPATH, '', GSDATAUPLOADPATH); //find name of uploads subdir
        $thumbsDirPart = str_replace(GSDATAPATH, '', GSTHUMBNAILPATH); //find name of uploads subdir

        //check that path is safe, etc.
        if(path_is_safe($filepath,GSDATAUPLOADPATH) && filepath_is_safe($file,$filepath)){
            //delete from uploads image,  thumb
            @unlink(GSDATAOTHERPATH . 'SpecialPagesExtras/thumbs_cache/extra-browser-thumbs/'.$uploadsDirPart.$path . $id);
            @unlink(GSDATAOTHERPATH . 'SpecialPagesExtras/thumbs_cache/image-field-thumbs/'.$uploadsDirPart.$path . $id);
            @unlink(GSDATAOTHERPATH . 'SpecialPagesExtras/thumbs_cache/multi-image-thumbs/'.$uploadsDirPart.$path . $id);
      
            //delete thumb for thumbnail 
            @unlink(GSDATAOTHERPATH . 'SpecialPagesExtras/thumbs_cache/extra-browser-thumbs/'.$thumbsDirPart.$path . 'thumbnail.'.$id);
            @unlink(GSDATAOTHERPATH . 'SpecialPagesExtras/thumbs_cache/image-field-thumbs/'.$thumbsDirPart.$path . 'thumbnail.'.$id);
            @unlink(GSDATAOTHERPATH . 'SpecialPagesExtras/thumbs_cache/multi-image-thumbs/'.$thumbsDirPart.$path . 'thumbnail.'.$id);
        }	
    }
    
    //used when GS deletes empty folder from uploads
    public function onFolderDelete(){
        $path = (isset($_GET['path'])) ? $_GET['path'] : '';
        $folder = $_GET['folder'];
        $target = GSDATAUPLOADPATH . $path . $folder;
        
        $uploadsDirPart = str_replace(GSDATAPATH, '', GSDATAUPLOADPATH); //find name of uploads subdir
        
        //check that path is safe for uploads
        if (path_is_safe($target,GSDATAUPLOADPATH)) {
       
            //removes empty directory, so we believe that all thumbs from that dir was deleted when user deleted files by admin panel
            @rmdir(GSDATAOTHERPATH . 'SpecialPagesExtras/thumbs_cache/extra-browser-thumbs/'.$uploadsDirPart.$path . $folder);
            @rmdir(GSDATAOTHERPATH . 'SpecialPagesExtras/thumbs_cache/image-field-thumbs/'.$uploadsDirPart.$path . $folder);
            @rmdir(GSDATAOTHERPATH . 'SpecialPagesExtras/thumbs_cache/multi-image-thumbs/'.$uploadsDirPart.$path . $folder);
        }
    }
   
    //work after all scripts
    public function confFooter(){

        if (!isset($_GET['copy'])) //copying old, load copy source settings
            $pageName = @$_GET['edit'] ? @$_GET['edit'] : $_POST['post-name']; //might be new one or eiditng old one
        else
            $pageName = @$_GET['copy'];
            
        $settings = $this->loadSpecialPageSettings($pageName); 
        
        $pageData = @$settings['pageData'];
        $fieldsData = @$settings['fieldsData'];
        
        include('confScripts.php'); //include all js 
        include('confDialogs.html'); //include dialogs html  
    }
    
    //save settings
    public function confSave(){        
        $fieldsData = array();
    
        for ($i=0; isset($_POST['cf_'.$i.'_name']); $i++) {
            $a = array(
                'name' => strtolower($_POST['cf_'.$i.'_name']), //all names are used in lowercase but sotred in i18special pages as not touched, weird 
				
                //supress errors, no javascript = empty vars
                'required' => @$_POST['spe_field-'.$i.'-required'] ? 1 : '',
                'description' => @$_POST['spe_field-'.$i.'-description'],
                'new-type' => @$_POST['spe_field-'.$i.'-new-type']
            );

            //store extra params for special types
            switch ($_POST['cf_'.$i.'_type']) {
                case 'image':{
                    $a['thumbnail'] = @$_POST['spe_field-'.$i.'-thumbnail'] ? 1 : '';
                    break;
                }    
				case 'text':
				case 'textfull':
				case 'textarea':{
                    $a['regex'] = @$_POST['spe_field-'.$i.'-regex'];
					
					//here is validation of php regullar expression passed from html form
					if (@preg_match($a['regex'], "Lorem ipsum") === false)
						$a['regex'] = ''; //reset to empty
					
                    break;
                }
            }
            
            $fieldsData[] = $a; //add to array
        }

        array_pop($fieldsData); // remove the last hidden line
        
        $this->_confWrite($fieldsData);
        
    }
    
    public function confUndo(){
        $name = preg_match('/^[A-Za-z0-9-]+$/', @$_GET['edit']) ? $_GET['edit'] : null;
        $newname = @$_GET['new'];
    
        //supress errors, no extra data
        @unlink(GSDATAOTHERPATH.'i18n_special-' . $newname . '-extras.xml'); //delete old
        @copy(GSBACKUPSPATH.'other/i18n_special-' . $name . '-extras.xml', GSDATAOTHERPATH.'i18n_special-' . $name . '-extras.xml');
    }
    
    
    public function confDelete(){
        $name = $_GET['delete']; 
         //supress errors, no extra data
        @copy(GSDATAOTHERPATH.'i18n_special-' . $name . '-extras.xml', GSBACKUPSPATH.'other/i18n_special-' . $name . '-extras.xml');
        @unlink(GSDATAOTHERPATH . 'i18n_special-' . $name . '-extras.xml');
    }


    public function loadSpecialPageSettings($pageName){
        $ret = array();
    
        $xml = getXML(GSDATAOTHERPATH.'i18n_special-' . $pageName . '-extras.xml');       
     
        //parse data from settings
        if ($xml){
            foreach ($xml->page->children() as $pageSetting)
            {
                $name = $pageSetting->getName();
                $ret['pageData'][$name] = (string)$pageSetting;
            }     

            foreach ($xml->fields->children() as $field)
            {      
                $fieldsData[] = array();
            
                foreach ($field->children() as $fieldSetting)
                {               
                    $name = $fieldSetting->getName();
                    $ret['fieldsData'][ count($fieldsData) - 1 ][$name] = (string)$fieldSetting;
                }
            }
        }
        
        return empty($ret) ? null : $ret;
    }

    //writes xml data
    private function _confWrite($fieldsData){    
        $data = @new SimpleXMLExtended('<?xml version="1.0" encoding="UTF-8"?><extras></extras>');
        $page = $data->addChild('page');
        
        $page->addChild('title-label-show', isset($_POST['spe_page-title-label-show']) ? 1 : '');
        $page->addChild('title-label')->addCData($_POST['spe_page-title-label']);
        $page->addChild('content-label-show', isset($_POST['spe_page-content-label-show']) ? 1 : '');
        $page->addChild('content-label')->addCData($_POST['spe_page-content-label']);
        $page->addChild('content-required', isset($_POST['spe_page-content-required']) ? 1 : '');
        $page->addChild('tags-hide', isset($_POST['spe_page-tags-hide']) ? 1 : '');
        $page->addChild('meta-description-hide', isset($_POST['spe_page-meta-description-hide']) ? 1 : '');
        $page->addChild('extra-browser', isset($_POST['spe_page-extra-browser']) ? 1 : '');
        
        $fields = $data->addChild('fields');
        
        for ($i = 0; $i < count($fieldsData); $i++){
            $f = $fields->addChild('field');
            
            //iterate over params and add to xml
            foreach ($fieldsData[$i] as $key => $value){
                $f->addChild($key)->addCData($value);
            }
        }
        
        //store backup
        $oldName = @$_GET['edit'];
        
        if ($oldName && file_exists(GSDATAOTHERPATH . 'i18n_special-' . $oldName . '-extras.xml')) {
            @copy(GSDATAOTHERPATH . 'i18n_special-' . $oldName . '-extras.xml', GSBACKUPSPATH . 'other/i18n_special-' . $oldName . '-extras.xml'); //create copy
            @unlink(GSDATAOTHERPATH . 'i18n_special-' . $oldName . '-extras.xml'); //delete old
        }
        
        //name must be with minus char not underscore to not be identified as special page type file
        XMLsave($data, GSDATAOTHERPATH . 'i18n_special-' . $_POST['post-name'] . '-extras.xml');
         
    }
    
    

}