<?php 

    global $SITEURL; 
    
    $uploadsDirPart = str_replace(GSROOTPATH, '', GSDATAUPLOADPATH); //find name of uploads subdir
?>

<script>
    $(document).ready(function() {  

        
        //generated by php
        var fieldsData = <?php echo json_encode($fieldsData) ?>;
        var pageData = <?php echo json_encode($pageData) ?>;
        var imageFieldNames = <?php echo json_encode($imageFieldNames) ?>;
        
        var $editForm = $('#editform'),
            reqImg = ' <img class="spe_img" src="../plugins/SpecialPagesExtras/img/required.png"  />';
           
        //page modifications
        if (pageData['title-label-show']){
            $('label[for="post-title"]').show();
            $editForm.addClass('title-label-visible');
        }      
        if (pageData['title-label']){
            $('label[for="post-title"]').html(pageData['title-label'])
            $('#post-title').removeAttr('placeholder');
        }    
        if (pageData['content-label-show']){
            $('label[for="post-content"]').show();
        }      
        if (pageData['content-label']){
            $('label[for="post-content"]').html(pageData['content-label']);
            $editForm.addClass('content-label-visible');
        }   
        if (pageData['content-required']){
            var $cLab = $('label[for="post-content"]');
            $cLab.html($cLab.html() + reqImg);
        }    
        if (pageData['tags-hide']){
            $('#post-metak').closest('p').hide();
        }    
        if (pageData['meta-description-hide']){
            $('#post-metad').closest('p').hide();
        }    
        if (pageData['extra-browser']){ //extra browser enabled so replace window.open with proxy
        
            //wait until whole page is loaded, on bottom there are i18n specialpages click handlers attached
            setTimeout(function(){
                $.each(imageFieldNames, function(index, val){
                    $('span.edit-nav a[id="browse-'+val.name+'"]')
                    .off('click')
                    .on('click', function(event){
                        event.preventDefault();
                        $.extraBrowser({
                            addImage : function(filename){
                                window['fill_sp_'+val.index]('<?php echo $SITEURL.$uploadsDirPart ?>'+filename);
                            }
                        });
                    });
                });
            }, 500);
        }

        //field modifications
        if (fieldsData){
      
            $.each(fieldsData, function(index, value){
                $input = $editForm.find(':input[id="post-sp-'+ value.name +'"]'),
                    $td = $input.closest('td'),
                    $b = $td.find('b');
	
                $b.text($b.text().slice(0,-1)); //remove : char auto added
                
                if ( value.description ){
                    $input.before('<div class="spe_description">' + value.description + '</div>');
                }    
                
                if ( value.required ){
                    $td.find('b:first').after(reqImg);
                }   

                
                //is image type and thumbnail parameter requested
                if (typeof(value.thumbnail) !== 'undefined' && value.thumbnail){
                    var $img = $('<img src="'+getThumbSrc( $input.val(), 'image-field-thumb')+'" class="spe_thumbnail" /> ');
                    $input.before($img);
                    
                    //on input change update thumbnail
                    $input.change(function(event){
                        $img.attr('src', getThumbSrc( $(this).val(), 'image-field-thumb' ) );
                    });
                    
                    //find number of field
                    var iNum = $editForm.find(':input[id^="post-sp-"]').index($input) + 1;
                    //override function used to fill input field after browse action
                    var oldFunc = window['fill_sp_' + iNum];
                    window['fill_sp_' + iNum] = function(url){
                        oldFunc(url);
                        $img.attr('src', getThumbSrc(url, 'image-field-thumb') );
                        $input.trigger('paste'); //not change only paste
                    };
                }
                
                if (value['new-type'] == 'multitext'){
					var multitextSortOpts = {            
						items:'.spe_row',
						helper : function(event, row){ //fixes resizing row issues
							return row.clone();
						},
						placeholder: {
							element: function(currentItem) { //fixes resizing row issues
								return multiTextRow('', true);
							},
							update: function(container, p) {
								return;
							}
						}
					};
				
                    $input
                        .hide()
                        .change(function(){ // use change handler to support changing data by language copier
                            var $inp = $(this);
   
                            $inp.siblings('.spe_multitext').remove(); 
                        
                            var values = $inp.val().split('||'),
                                html = '<div class="spe_multitext">';
                            
                            for (var i=0; i < values.length; i++)
                            { 
                                html += multiTextRow(values[i]);
                            }
                            html += '<button type="button" class="spe"><?php i18n('SpecialPagesExtras/ADD') ?></button>';
                            html += '</div>';
                            
                            var $multiDiv = $(html);
     
                            $inp.closest('td').append($multiDiv);
                            
                            //sortable fields
                            $multiDiv.sortable(multitextSortOpts);
                            
                        })
                        .trigger('change');
                }   

				if (value['new-type'] == 'multiimage'){
                    $input
                        .hide()
                        .change(function(){ // use change handler to support changing data by language copier
                            var $inp = $(this);
                            $inp.siblings('.spe_multiimage').remove(); 
                        
                            var val = $inp.val(),
								values = val ? val.split('||') : [],
                                html = '<div class="spe_multiimage"><ul>';

                            for (var i=0; i < values.length; i++){ 
                                html += multiImageCell(values[i]);
                            }
							
                            html += '</ul>';
                            html += '<button type="button" class="spe"><?php i18n('SpecialPagesExtras/ADD') ?></button>';
                            html += '</div>';
                            
                            var $multiDiv = $(html);
     
                            $inp.closest('td').append($multiDiv);
                            
                            //sortable fields
                            $multiDiv.find('> ul').sortable();
                            
                        })
                        .trigger('change');
                }
            });
        }
        
        //multitext delete handler
        $editForm.on('click', '.spe_multitext .spe_delete', function(event){
            event.preventDefault();
            
            var $a = $(this);
            $a.closest('td').find('input:first').trigger('paste'); //trigger change event, use paste!
            $a.closest('.spe_row').remove();
        });    

		//multiimage delete handler
		$editForm.on('click', '.spe_multiimage .spe_delete', function(event){
            event.preventDefault();
            
            var $a = $(this);
            $a.closest('td').find('input:first').trigger('paste'); //trigger change event use paste!
            $a.closest('.spe_cell').remove();
        });  

		
         //multitext add handler
        $editForm.on('click', '.spe_multitext button.spe', function(event){
            event.preventDefault();
            
            var $button = $(this);
            $button.before(multiTextRow(''));
            $button.closest('td').find('input:first').trigger('paste'); //trigger change event use paste!
        });  
		
		

		//multiimage add handler
		var $multiimageUl = null;
		
		//function used when selected image
		window.spe_multiimageSelected = function(url){
			$multiimageUl.append(multiImageCell(url));
		};
		
        $editForm.on('click', '.spe_multiimage button.spe', function(event){
            event.preventDefault();
            
            var $a = $(this),
				$ul = $a.siblings('ul:first');
				
            $multiimageUl = $ul;
            
            if (pageData['extra-browser']){
                $.extraBrowser({
                    multipleSelection : true,
                    addImage : function(filename){
                        spe_multiimageSelected('<?php echo $SITEURL.$uploadsDirPart ?>'+filename);
                    }
                });
            }
            else{
                window.open('<?php echo $SITEURL; ?>plugins/i18n_specialpages/browser/filebrowser.php?func=spe_multiimageSelected&type=images', 'browser', 'width=800,height=500,left=100,top=100,scrollbars=yes');
            }
			
            
            $a.closest('td').find('input:first').trigger('paste'); //trigger change event use paste!
        });
		

        
        var openOptions = false,
			skipAsyncValidation = false; //used when async validation passed
			
        $editForm.submit(function(event){     

            //fill multitext
            $editForm.find('.spe_multitext').each(function(){
                var $multiText = $(this),
                    $input = $multiText.siblings('input[type="text"]'),
                    vals = [];
                    
                $multiText.find('input').each(function(){
                    var val = $(this).val(); //remove empty fields
                    
                    vals.push(val);
                });
                
                $input.val(vals.join('||'));
            });  

			//fill multiimage
            $editForm.find('.spe_multiimage').each(function(){
                var $multiImage = $(this),
                    $input = $multiImage.siblings('input[type="text"]'),
                    vals = [];
                    
                $multiImage.find('input').each(function(){
                    var val = $(this).val().trim();
                    
                    if (val)
                        vals.push(val);
                });
                
                $input.val(vals.join('||'));
            });
			
                
            if (typeof CKEDITOR != 'undefined' && CKEDITOR.instances){
                //update now
                for(var i in CKEDITOR.instances) {
                   /* this updates the value of the textarea from the CK instances.. */
                   CKEDITOR.instances[i].updateElement();
                }
            }
			
			if (skipAsyncValidation){
				skipAsyncValidation = false; //used when title is empty and first validation async is passed
				return true;
			}

			lockUI();
			
			$.ajax({
			  type: "POST",
			  url: '<?php echo $SITEURL; ?>plugins/SpecialPagesExtras/validator/?cachebust=' + (new Date()).getTime(),
			  data: $editForm.serialize(),
			  dataType: 'json'
			})
			.done(function(data){
				unlockUI();
                
                //clear previous errors
                unmarkInvalids();
			
				if (data === 1){ //success  
					skipAsyncValidation = true;
					$('#page_submit').trigger('click'); //submit form
				}		
				else if ($.isArray(data) && data.length){ //fields failed 
					
					$.each(data, function( index, value ) {
						var name = value;
						if (value.lastIndexOf('!') != -1){ //is multitext regex validation
							var splited = value.split('!'), 
								indexes = splited[1].split(','); //find wrong regex indexes inputs
							name = splited[0];
						}
					
						var $input = $editForm.find('*[name="' + name+ '"]'); //main input

						if (indexes){ //multitext regex validation
							$.each(indexes, function( index, value ) {
								markFieldInvalid($input.siblings('.spe_multitext').find('.spe_row:eq('+value+') input'));
							});
						}
						else{ //normal field
							markFieldInvalid($input);
						}
						
					});
					
					showValidationError();
				}
				else{
					alert('SpecialPagesExtras: async validation failed.');
				}
			})
			.fail(function(){
				alert('SpecialPagesExtras: async validation error.');
			});
			
			event.preventDefault();
        });
		
		
		function lockUI(){
			$editForm.animate({opacity: 0.5}); //pseudo lock
			
			$editForm.on("keydown.spe keypress.spe keyup.spe", keyboardLocker);
		}	

		function unlockUI(){
			$editForm.stop().css('opacity', '');
			
			$editForm.off('.spe');
		}
		
		function keyboardLocker(event){
			event.preventDefault();
		}
		
		function showValidationError(){
			if (openOptions && $('#metadata_window').is(':hidden') ){
                $('#metadata_window').slideToggle('fast');
                $('#metadata_toggle').toggleClass('current');
            }
		
			//there are some errors
            if ($editForm.find('.spe_validation-error').length){
                $('.notify_error').remove();

                var m = notifyError("<?php i18n('SpecialPagesExtras/VALIDATION_ERROR');?>");
                
                setTimeout(function(){
                    m.popit();
                }, 400);
                            
                if ($('body,html').scrollTop() > 120){
                    $('body,html').animate({scrollTop: 0}, 400);
                }
            }   
		}
        

		function markFieldInvalid($input){
			var $td = $input.closest('td');

			if ($input.next('span[id^="cke_"]').length){ //is cke editor
				$input.next('span[id^="cke_"]').addClass('spe_validation-error');
			}
			else if ($input.closest('.spe_multitext').length){
				$input.addClass('spe_validation-error');
			}
			else{
				$td.addClass('spe_validation-error');
			}
			
			//is part of special fields
			if ($input.closest('.specialtable').length)
				openOptions = true;
		}		
		
		function unmarkInvalids($input){
			$editForm.find('.spe_validation-error').removeClass('spe_validation-error');
		}
        
        function getThumbSrc(imgUrl, mode){
            return '<?php echo $SITEURL; ?>plugins/SpecialPagesExtras/thumb/?mode=' + mode + '&img='+ encodeURIComponent(imgUrl) +'&no=<?php urlencode(i18n('SpecialPagesExtras/IMAGE_NO_IMAGE'));?>&ni=<?php urlencode(i18n('SpecialPagesExtras/IMAGE_NOT_IMAGE'));?>&nf=<?php urlencode(i18n('SpecialPagesExtras/IMAGE_NOT_FOUND'));?>';
        }     

        function multiTextRow(value, empty){
            return '<div class="spe_row"><div class="spe_cell">' + (empty ? '' : '<input type="text" class="text" value="'+value.replace(/"/g, '&quot;')+'" />')+'</div><div class="spe_cell spe_delete">'+ (empty ? '' : '<a href="#"  title="<?php i18n('SpecialPagesExtras/DELETE') ?>">X</a>')+ '</div><div class="spe_cell spe_drag"><img class="spe_img" src="../plugins/SpecialPagesExtras/img/drag.png"  /></div></div>'
        } 

		function multiImageCell(value){
            return '<li class="spe_cell"><input type="hidden" value="'+value+'" /><img src="'+getThumbSrc(value, 'multi-image-thumb')+'" /><div class="spe_delete"><a href="#" title="<?php i18n('SpecialPagesExtras/DELETE') ?>">X</a></div></li>'
        }
    });
</script>