<?php
require_once('../../../gsconfig.php');
$admin = defined('GSADMIN') ? GSADMIN : 'admin';

require_once("../../../${admin}/inc/common.php");
$loggedin = cookie_check();

if (!$loggedin) 
	die('Not logged in!');
	
if(!defined('IN_GS')){ 
	die('you cannot load this page directly.'); 
}

require_once('../EGImage.php');

$sizes = array(
    'image-field-thumb' => array( 'width' => 300, 'height' => 200, 'cacheDir' => 'image-field-thumbs/' ),
    'multi-image-thumb' => array( 'width' => 148, 'height' => 111, 'cacheDir' => 'multi-image-thumbs/' ),
    'extra-browser-thumb' => array( 'width' => 180, 'height' => 120, 'cacheDir' => 'extra-browser-thumbs/' )
);

$errorNoImage = @$_GET['no'];
$errorNotFound = @$_GET['nf'];
$errorNotImage = @$_GET['ni'];

$mode = @$_GET['mode'];

$requestedPath =  @$_GET['img']; //requested path

try {
    if ( !in_array($mode, array('image-field-thumb', 'multi-image-thumb', 'extra-browser-thumb')) )
        throw new Exception('Unknown mode');

    if (empty($requestedPath)){
        throw new Exception($errorNoImage); //empty image
    }
    
    $dataDirPart = str_replace(GSROOTPATH, '', GSDATAPATH);

    $host = $_SERVER['SERVER_NAME'] . ($_SERVER['SERVER_PORT'] != '80' ? ':'.$_SERVER['SERVER_PORT'] : '');
    $pathParts = pathinfo($_SERVER['PHP_SELF']);
    $subDir = str_replace('plugins/SpecialPagesExtras/thumb', '', $pathParts['dirname']); //find page subdir
    $port = ($p=$_SERVER['SERVER_PORT'])!='80'&&$p!='443'?':'.$p:'';
    $siteHost = http_protocol()."://". $host . $port;
    
    $cacheDir = GSDATAOTHERPATH . 'SpecialPagesExtras/thumbs_cache/';
    $cacheDir .= $sizes[$mode]['cacheDir'];
    
    if ($mode == 'extra-browser-thumb'){
        $requestedFile = basename($requestedPath);
        $requestedPath = str_replace(GSDATAPATH, '', GSDATAUPLOADPATH).tsl(dirname($requestedPath));  //make path the same as in oter modes
    }
    else{
        //delete site host and dir and data from image url
        if ( substr($requestedPath, 0, strlen($siteHost.$subDir.$dataDirPart) ) == $siteHost.$subDir.$dataDirPart) {
            $requestedPath = substr($requestedPath, strlen($siteHost.$subDir.$dataDirPart));
        }
        else if (substr($requestedPath, 0, strlen($subDir.$dataDirPart) ) == $subDir.$dataDirPart){ //if its root relative (ex. /data/uploads/image.jpg)
            $requestedPath = substr($requestedPath, strlen($subDir.$dataDirPart));
        }
        else{ //wrong path, reset to fail later
            $requestedPath = '';
        }
            
        $requestedFile = basename($requestedPath);
        $requestedPath = tsl(dirname($requestedPath)); 
    }
    
    $sourceFile = GSROOTPATH.$dataDirPart.$requestedPath.$requestedFile;
    
    if (!filepath_is_safe($sourceFile, GSDATAPATH))
        throw new Exception($errorNotFound); //may be not safe
    
    //file exists and its modification date is older than source
    $cachedExists = file_exists($cacheDir.$requestedPath.$requestedFile) && @filemtime($sourceFile) <= filemtime($cacheDir.$requestedPath.$requestedFile);
    
    if ($cachedExists){
        $sourceFile = $cacheDir.$requestedPath.$requestedFile;
    }

    $t = new EGImage($sourceFile);
    
    if (!$cachedExists){
        $t->resize($sizes[$mode]['width'], $sizes[$mode]['height'], 'fit', true);
        
        if ( !file_exists(dirname($cacheDir.$requestedPath.$requestedFile)) ){ //directory not exists, prepare one, requsivly
            mkdir(dirname($cacheDir.$requestedPath.$requestedFile), 0755, true);
        }
        
        $t->save($cacheDir.$requestedPath.$requestedFile, 92);
    }
    
    $t->render(172800); //two days
} catch (Exception $e) {
    sendError($e->getMessage(), @$sizes[$mode]['width'], @$sizes[$mode]['height']);
}

function sendError($message, $width, $height) {
    $width = $width ? $width : 148; //might be empty when unknown mode
    $height = $height ? $height : 111;

    $im = ImageCreateTrueColor($width, $height);
    imagefill( $im, 0, 0, ImageColorAllocate($im, 255, 255, 255));

    imageCenterString ($im, 2, $message, ImageColorAllocate($im, 0, 0, 0));

    ImageRectangle($im, 0, 0, $width-1, $height-1, ImageColorAllocate($im, 200, 200, 200)); 

    header("Cache-Control: no-store");
    header('Expires: '.gmdate('D, d M Y H:i:s', time()-1000).' GMT');
    header('Content-Type: image/jpeg');
    ImageJpeg($im);
    ImageDestroy($im);
    exit();
}

function imageCenterString(&$img, $font, $text, $color){
    if($font < 0 || $font > 5){ $font = 0; }
    $num = array(array(4.6, 6),
              array(4.6, 6),
              array(5.6, 12),
              array(6.5, 12),
              array(7.6, 16),
              array(8.5, 16));
    $width = ceil(strlen($text) * $num[$font][0]);
    $x     = imagesx($img) - $width - 8;
    $y     = Imagesy($img) - ($num[$font][1] + 2);
    imagestring($img, $font, $x/2, $y/2, $text, $color);
}
